default shark_enable = True
default shark_overlay_enable = False
default shark_theme = 0

init python:

    SHARK_THEMES = [
        ("#000000", "#FFFFFF"),
        ("#104110", "#9cb912"),
        ("#0000AA", "#58FDFF"),
        ("#000000", "#00AA01"),
        ("#AA0000", "#FFFFFF"),
        ("#0000AA", "#FFFF55"),
        ("#AA00A9", "#FFFF55"),
        ("#000000", "#FF5555"),
        ("#555555", "#AAAAAA"),
        ("#AA00A9", "#58FDFF")
    ]

    shark_themes = [ ]

    for a, b in SHARK_THEMES:
        shark_themes.append((Color(a).rgba, Color(b).rgba))

    renpy.register_shader(
        "renpy.shark",
        variables="""
            uniform vec2 res0;
            uniform vec4 u_dark;
            uniform vec4 u_light;
        """, fragment_900="""
            float ret = dot(v_tex_coord * res0, vec2(2.0, 7.0) / 17.0);
            ret = mod(ret, 1) * .99 + 0.005;

            if (gl_FragColor.a < 0.1) {
                gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
            } else if (gl_FragColor.g >= ret) {
                gl_FragColor = u_light;
            } else {
                gl_FragColor = u_dark;
            }
        """
    )

    def shark_emulator(d):
        if renpy.display.draw is None:
            return d

        if not shark_enable:
            return d

        d = Transform(d, shader="renpy.shark", mesh=True, u_dark=shark_themes[shark_theme][0], u_light=shark_themes[shark_theme][1])
        return d

    config.layer_transforms[None] = [ shark_emulator ]

    config.overlay_screens.append("shark_preferences")


screen shark_preferences:
        zorder 10

        key "k" action ToggleVariable("shark_overlay_enable")

        if shark_overlay_enable:

            frame:
                padding (10, 10)
                align (0.5, 0.5)

                has vbox

                text "Shark Emulator Preferences"

                null height 10

                if shark_enable:
                    textbutton "Disable Shark Emulator" action ToggleVariable("shark_enable")
                else:
                    textbutton "Enable Shark Emulator" action ToggleVariable("shark_enable")

                textbutton "Resize to Shark Native (960x540)" action Function(renpy.set_physical_size, (960, 540)) selected (renpy.get_physical_size() == (960, 540))

                text "Color Scheme:"

                hbox:
                    for i in range(0, len(SHARK_THEMES)):
                        textbutton "[i]" action SetVariable("shark_theme", i)

style default:
    antialias False
    outlines [ (4, "#000", 0, 0), (0, "#fff", 0, 0) ]
